<?php

    session_start();
    $admin_root = "..";
    $site_root = "../..";

    // ====== Load Functions Libraries ======

    require "$admin_root/repository/functions.php";
    require "$admin_root/repository/cms.php";
    require "$admin_root/repository/xml.php";
    $login = "$admin_root/login.php";
    require "$admin_root/modules/_security.php";

?>

<!doctype html>
<html lang='<?php echo $_SESSION["admin_lang"]; ?>'>
	<head>
		<meta charset="UTF-8">
		<title>X.able CMS / Xable-Jable Cleaner</title>
		<link href='http://fonts.googleapis.com/css?family=Lato:100,300,400,700,900|Inconsolata:400,700|Audiowide&subset=latin,latin-ext' rel='stylesheet' type='text/css'>
        <link rel="stylesheet" type="text/css" href="<?php echo "$admin_root/_tools/_tools.css?v=0000" ?>" />
        <style>
            #outputs {
                position: relative;
                padding-bottom: 15px;
                overflow: hidden;
            }
            textarea {
                display: block;
                float: left;
                margin: 0;
                padding: 0;
                width: 50%;
                height: 300px;
                resize: none;
            }
        </style>
    </head>
    <body>
        <button class='close' onclick="self.close()">X</button>
        
<?php

    function jableCleaner($root) {
    
        $path = "$root/tmp/xable-jable";
        if(file_exists($path) && is_dir($path)) {
            removeDir($path);
            echo "[Remove directory:] \"$path\"<hr>\n";
        }

        $deleted = [];
        foreach(filesTree($root, ".") as $path) {
            $ext = path($path, "extension");
            $basename = path($path, "basename");
            if(!in_array($ext, [ "xml", "php", "js", "css", "json" ]) && strstr($basename, ".xml.")) {
                unlink($path);
                echo "[Deleted:] \"$path\"<br>\n";
                $deleted[] = $path;
            }
        }
        if(count($deleted) > 0) {
            echo "<hr><p>".count($deleted)." files deleted.</p>\n";
        }
        else {
            echo "<p>Nothing to delete found.</p>\n";
        }

    }
        
    echo "<h1>Xable-Jable Cleaner</h1><hr>\n";
    if(isset($_POST["action"]) && $_POST["action"] == "delete") {
        jableCleaner($site_root);
    }
    else {
        echo "<form method='post'>\n";
        echo "<p>Delete all XML remains after update from 4 to 5.</p>\n";
        echo "<button name='action' value='delete' type='submit'>Submit</button>\n";
        echo "</form>\n";

        if(isset($_POST["action"]) && $_POST["action"] == "convert") {
            $xml = $_POST["xml"];
            $array = xmlToArray($xml)["xable"][0];
            $json = arrayToJson($array);
        }
        else {
            $xml = "";
            $json = "";
        }
        
        echo "<br><hr>\n";
        echo "<form method='post'>\n";
        echo "<p>Covert XML code to JSON</p>\n";
        echo "<div id='outputs'>\n";
        echo "<textarea id='xml' placeholder='XML' name='xml'>$xml</textarea>\n";
        echo "<textarea id='json' placeholder='JSON' disabled>$json</textarea>\n";
        echo "</div>\n";
        echo "<button name='action' value='convert' type='submit'>Convert</button>\n";
        echo "</form>\n";
    };

?> 
        
    </body>
</html>