<?php
    $max_media = 500;

    $pages = $_SESSION["site_folders"]["pages"];
    $dynamic_xml = [];
    //echo "PAGES: $pages\n";
    $media_list = [ "images" => [], "files" => [], "videos" => [] ];

    $done = [];
    foreach(filesTree($pages, "json,draft,?") as $file) {
        //echo "[File] $file<br>\n";
        $folder = path($file, "dirname");
        $filename = getFilename($file);
        $filepath = "$folder/$filename.json";
        if(!in_array($filepath, $done)) {
            //echo "[File] $filepath<br>\n";
            $done[] = $filepath;
            
            $xml = loadXml($filepath, "draft", true);
            unset($xml["_file_manager"]);
            //arrayList($xml);
            foreach($xml as $artcile_group) {
                foreach($artcile_group as $article) {
                    foreach($article as $section) {
                        
                        if($section[0]["type"][0] == "media") {
                            
                            $media = $section[0]["media"][0];
                            //arrayList($media);
                            foreach(array_keys($media) as $media_type) {
                                
                                $media_val = $media[$media_type][0];

                                foreach(explode(";", $media_val) as $item) {

                                    if($item != "" && !is_dir("$root/$item") && file_exists("$root/$item")) {
                                        if(in_array($media_type, [ "image", "gallery" ])) {
                                            $media_list["images"][] = [ "media" => $item, "page" => $filepath ];
                                        }
                                        else {
                                            $media_list["files"][] = [ "media" => $item, "page" => $filepath ];
                                        }
                                    }
                                    elseif(strstr($item, "://")) {
                                        $media_list["videos"][] = [ "media" => $item, "page" => $filepath ];
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        
    };
    //arrayList($media_list);

    $dynamic_xml = [];
    foreach(array_keys($media_list) as $type) {
        $files = [];
        foreach($media_list[$type] as $media) {
            $files[$media["media"]] = $media["media"].":".$media["page"];
        };
        $item = [];
        if($type == "videos") {
            $item["type"][0] = "media";
            $item["set"][0] = "video";
            $item["media"][0]["video"][0] = join(";", array_keys($files));
            
        }
        elseif($type == "files") {
            $item["type"][0] = "media";
            $item["set"][0] = "files";
            $item["media"][0]["files"][0] = join(";", array_keys($files));
        }
        elseif($type == "images") {
            $item["type"][0] = "media";
            $item["set"][0] = "gallery";
            $item["media"][0]["gallery"][0] = join(";", array_keys($files));
        };
        
        $connections = [];
        $connections["type"][0] = "code";
        $connections["disabled"][0] = "true";
        $connections["code"][0] = join("[br]", $files);
        
        $dynamic_xml[$type][0]["media"][0] = $item;
        $dynamic_xml[$type][0]["connections"][0] = $connections;
    };

    echo "\t\t<script src='script/media_list.js?v=".$last_update."'></script>\n";

?>