// ==========================================
//          Define Constant Variables
// ==========================================

var ANIMATION_TIME = 250;

var SITE_ROOT;
var CURRENT_PATH;
var EDIT_PATH;
var SAVE_PATH;
var LANGUAGES;
var LANG;
var ADMIN_LANG;
var TEXTAREA_MIN; // Minimal textarea height
var SCROLL_MEMO;
var BROWSE_DATA;
var TOUCH_SCREEN;

var SITE_NEW_BELOW;

// ==========================================
// ==========================================
// ==========================================
//            Launch CMS scripts
// ==========================================
// ==========================================
// ==========================================

$(document).ready(function() {
    
    // ==========================================
    //           Set Global Variables
    // ==========================================
    
    SITE_ROOT = $("input#root").val();
    CURRENT_PATH = $("input#path").val();
    EDIT_PATH = $("input#edit_path").val();
    SAVE_PATH = $("input#save_path").val();
    LANGUAGES = $("input#languages").val().split(",");
    LANG = $("input#edit_lang").val();
    ADMIN_LANG = $("input#admin_lang").val();
    
    if($("#site_new_below").length) {
        SITE_NEW_BELOW = $("#site_new_below").val().split(",");
    }
    else {
        SITE_NEW_BELOW = "multi_page";
    };
    
    if("ontouchstart" in window) { TOUCH_SCREEN = true } else { TOUCH_SCREEN = false; };

    disableEnterInForm();
    
    // ==========================================
    //           Float HEADER Buttons
    // ==========================================

    SCROLL_MEMO = $(window).scrollTop();
    launchFloatHeader();

    // ==========================================
    //              Date / Calendar
    // ==========================================
    
    launchDate();

    // ==========================================
    //               Action Button
    // ==========================================

    initializeActionButtons();
    
    // ==========================================
    //                Navigation
    // ==========================================
    
    launchNavigation();
    setMainTitle();
    updatePath();
    launchTreeBrench();
    launchCountInfo();
    launchPreviewPageButton();
    
    // Browse file + Navigation Title autofill
    BROWSE_DATA = getBrowseData();
    initializeBrowseInput();
    setTimeout(function() { checkNavigationDuplications(); }, ANIMATION_TIME * 4);
    launchNavigationEdit();
    fixNavigationNoTitle();

    // Responsive navigation
    initializeMobileMenuButton();
    resposive();
    $(window).resize(function() { resposive() });
    
    // ==========================================
    //                  Search
    // ==========================================
    
    launchSearchButton();
    launchScrollToSearch();
    
    // ==========================================
    //              Header Buttons
    // ==========================================
    
    launchHeaderButtons();
    
    // ==========================================
    //                Translate
    // ==========================================

    lauchDictionary();
    
    // ==========================================
    //            User & Notifications
    // ==========================================
    
    launchUnpublishedList();
    launchHeaderPulldowns();
    
    // ==========================================
    //                 Languages
    // ==========================================
    
    launchLanguages();
    hideShowLangMenu();
    changeLanguage();
 
    // ==========================================
    //                   Table
    // ==========================================
    
    tableHeadings();
	initializeTable();

    // ==========================================
    //             Text Style Editor
    // ==========================================
    
    initializeShowStyle();

    // ==========================================
    //         Buttons & Article headers
    // ==========================================

	setPostButtons();
    initializeNewPost();
    initializePostButtons();
    launchDraggableOrder();
    
    // ==========================================
    //              File(s) upload
    // ==========================================
    
    removeUninkedDescriptions();
    transparentBackground();
	initializeMediaPreview();
    initializeUpload();
	uploadHideShow();
	
    // ==========================================
    //                  Images
    // ==========================================
    
    showNotFoundImages();
	initializeDeleteMedia();
    initializeSet();
    mediaHideShow();
    singleSetHide();
    //updateMediaValue();
    launchDraggableGallery();

    // ==========================================
    //           Section fold & expand
    // ==========================================
    
    launchSectionFold();
    
    // ==========================================
    //              Gerate XML code
    // ==========================================

    updateOutput();
    launchCodePreview();
    
    // ==========================================
    //            Order Sort Options
    // ==========================================
    
    launchOrderTagMap();
    initializeOrderOptions();
	
    // ==========================================
    //             Disabled & Hidden
    // ==========================================

	initializeDisabled();
    
    // ==========================================
    //               New document
    // ==========================================

    updateTemplatePathes();
    
    // ==========================================
    //              Edit template
    // ==========================================

    templateUpload();
    
    // ==========================================
    //               Media list
    // ==========================================

    mediaListPage();
    
    // ==========================================
    //                  Popups
    // ==========================================

    initializeHelp();
    showInitialPopup();
    $(window).scroll( function() { $("#help_popup").hide() });
    
    // ==========================================
    //             Detect changes
    // ==========================================
    
    TEXTAREA_MIN = 120; // Minimal textarea height
    launchDetectChanges();
    initializeDectectChanges();

    
    // ==========================================
    //                Launch CMS
    // ==========================================

    $(window).resize(function() { formResize(ANIMATION_TIME); });
    updatePath();
    launchCms();
    
});