// ==========================================
//   Browse file + Navigation Title autofill
// ==========================================

var NAVIGATION_TITLES = false;

function getBrowseData() {
    var mediaFolders = $("#media_folders").val().split(";");
    var pagesFiles = $("#pages_files").val().split(";");
    var pages_path = "pages/";
    for(i in pagesFiles) {
        file = pagesFiles[i];
        dir = file.path("dirname").substr(pages_path.length);
        if(dir != "") { file = dir + "/" + file.path("filename"); }
        else { file = file.path("filename"); };
        if(file != "") { pagesFiles[i] = file; }
    };
    return { "media": mediaFolders, "pages": pagesFiles };  
};

function initializeBrowseInput() {
    // Load date(s) from php
    $("form section .browse_box").each(function() {
        $section = $(this).closest("section");
        href = $section.find("input.string").val();
        $section.find(".browse_box input").val(href);
    });

    // Auto update Title on change
    $("form section .browse_box input").unbind("change").change(function() {
        $section = $(this).closest("section");
        href = $(this).val();
        $section.find("input.string").val(href);
        $title = $section.closest("article").find("section.title div.text input");
        updateNavigationTitles($title);
        checkNavigationDuplications();
    })

    // ====== Button ======
    $("form section .browse_box button.browse").unbind("click").click(function() {
        $section = $(this).closest("section");
        section_tag = $section.attr("class");
        browse_pages_tags = [ "href", "href_404" ];
        if(browse_pages_tags.indexOf(section_tag) > -1) {
            pathes_list = BROWSE_DATA["pages"];
            showPopup("fi-folder", LOCALIZE["browse-file-info"], LOCALIZE["apply-cancel-buttons"], pathes_list);
        }
        else {
            pathes_list = BROWSE_DATA["media"];
            showPopup("fi-folder", LOCALIZE["browse-folder-info"], LOCALIZE["apply-cancel-buttons"], pathes_list);
        };

        href = $section.find(".browse_box input").val();
        if(href != "" && pathes_list.indexOf(href) > -1) {
            $("#popup_box select").val(href);
        }

        $("#popup_box .confirm").click(function() {
            href = $("#popup_box select").val();
            if(href != "") {
                $section.find(".browse_box input").val(href);
                $section.find("input.string").val(href);

                $title = $section.closest("article").find("section.title div.text input");
                updateNavigationTitles($title);
                checkNavigationDuplications();

                hidePopup();
            }
            else {
                infoPopup(LOCALIZE["required-select-option"]);
            };
        });
        $("#popup_box .cancel").click(function() { hidePopup(); });
        return false;
    })
};

// ====== Navigation autofill ======
function checkNavigationDuplications() {
    // ====== Check for duplicated href ======
    href_list = [];
    duplicated = [];
    $("form article.multi_page").each(function() {
        href = $(this).find("section.href input.string").first().val();
        //alert("href: " + href);
        if(href_list.indexOf(href) > -1) { duplicated[duplicated.length] = href; };
        href_list[href_list.length] = href;
    });
    if(duplicated.length) {
        setTimeout(function() {
            showPopup("fi-alert", LOCALIZE["navigation-href-duplicated"] + "<br>" + duplicated.join(", "), LOCALIZE["ok-label"]);
            $("#popup_box .confirm").click(function() { hidePopup(); });
        }, 500)
    };
};

function updateNavigationTitles($title) {
    if(typeof(NAVIGATION_TITLES) == "object") {
        // Update title
        var updated = false;
        $article = $title.closest("article");
        href = $article.find("section.href input.string").first().val();
        titles = NAVIGATION_TITLES[ SITE_ROOT + "/pages/" + href + ".json" ];
        if(typeof(titles) == "object") {
            for(language in titles) {
                $title = $article.find("section.title div.text input." + language);
                if($title.length) {
                    $title.val( titles[language] );
                    var updated = true;
                }
            }
        };
        // Disable/enable edit
        $title = $article.find("section.title div.text input");
        if(updated) {
            $title.prop("disabled", true);
            $title.closest("div.text").click(function() {
                infoPopup(LOCALIZE["navigation-title-autofill-info"]);
                return false;
            })
        }
        else {
            $title.prop("disabled", false);
            $title.closest("div.text").unbind("click");
        };
    };
};

function launchNavigationEdit() {
    // ====== Launch update on navigation + option=true ======
    if(SAVE_PATH == SITE_ROOT + "/navigation.json" && $("#site_auto_navigation_title").val() == "true") {
        NAVIGATION_TITLES = {};
        $("nav dd").each(function() {
            if($(this).attr("data-type") == "page") {
                $label = $(this).find(".item_label").first();
                if($label.find(".lang_title").length) {
                    href = $label.attr("href");
                    //alert(href);
                    titles = {};
                    $label.find(".lang_title").each(function() {
                        var language = $(this).attr("class").split(" ").pop();
                        var title = $(this).text();
                        titles[ language ] = title;
                    })
                    NAVIGATION_TITLES[href] = titles;
                }
            }
        });

        $("form article.multi_page").each(function() {
            $title = $(this).find("section.title div.text input");
            updateNavigationTitles($title);
        });
    }
    else {
        NAVIGATION_TITLES = false;
    };
};

function fixNavigationNoTitle() {
    // Must be after launchNavigationEdit();
    $("nav dd").each(function() {
        $dd = $(this);
        if($dd.attr("data-type") == "page") {
            $label = $dd.find(".item_label").first();
            if($label.find(".lang_title").length) {
                href = $label.attr("href");
                
                $label.find(".lang_title").each(function() {
                    var language = $(this).attr("class").split(" ").pop();
                    var title = $(this).text();
                    if(href.path("extension") == "template") {
                        $dd.find(".item_icon i").removeClass("fi-page").addClass("fi-page-edit");
                        $(this).html("<em class='no_title'>" + href.path("filename").replace("_", " ").capitalize() + "</em>");
                    }
                    else if(title == "") {
                        $(this).html("<em class='no_title manual color_draft' help='" + LOCALIZE["no-title"] + "'>" + href.path("filename") + "</em>");
                    }
                })
            }
        }
    });
};

// ==========================================
//                Navigation
// ==========================================

function launchNavigation() {

    // mark destination Branch for new page
    if(EDIT_PATH.path("extension") == "template") {

        var group_folder = SAVE_PATH.path("dirname");
        var group = false;

        $("nav dd.add_page").each(function() {
            var $dd = $(this).closest("dl").children("dd").first();
            var folder = $dd.children("div").find(".item_label").attr("href").path("dirname");

            if(group_folder == folder) {
                if($dd.closest("dd.folder").length) {
                    $parent = $dd.closest("dd.folder");
                    group = $parent.children("div").find(".item_label p").html();
                }
                else if($dd.closest("dl").children("dt").length) {
                    $parent = $dd.closest("dl").children("dt");
                    group = $parent.children("div").find(".item_label p").html();
                }
                else {
                    group = "-";
                }

                // Mark Add Page button as Current
                //$parent.children("div").addClass("current");
                $parent.children("dl").children("dd.add_page").children("div").addClass("current");
                // Put group name to the title
                title = $("main h2").html().replace("@group", group);
                $("main h2").html(title);
                $("main h2 i").remove();
            }
            else {
                $(this).children(".current").removeClass("current").addClass("active_item");
                $(this).find(".item_label").css({ "opacity": 0.4 });
            }
        })
        // New group
        if(!group) {
            $("nav dd").each(function() {
                var href = $(this).children("div").find(".item_label").attr("href");
                if((group_folder + ".json") == href) {
                    // Mark parent item as Current
                    $(this).children("div").addClass("current");
                    // Put group name to the title
                    group = $(this).children("div").find(".item_label p").html();
                    title = $("main h2").html().replace("@group", group);
                    $("main h2").html(title);
                    $("main h2 i").remove();
                }
            })
        }
    };

    // Protected files - disable page remove option
    protected_files = [];
    $("nav").find("dl").first().children("dd").each(function() {
        var href = $(this).children("div").find(".item_label").attr("href");
        if(jQuery.type(href) == "string" && href != "") {
            protected_files[protected_files.length] = href;
        }
    });

    // Resize clicable labels
    $("nav dd div.nav_item").each(function() {
        wid = $(this).width(); // + parseInt($(this).css("padding-left")) + parseInt($(this).css("padding-right"));
        $indent = $(this).find(".item_indent");
        wid = wid - ( $indent.width() * $indent.length ) - 25;
        $(this).find(".item_label").css({ "width": wid });
    })

    // Resize long titles
    $("nav dd > .nav_item").each(function() {
        $title = $(this).find(".item_label span." + LANG).first();
        //$title.css({ "font-size": "inherit"});
        //$title.closest("button").css({ "line-height": "inherit" });
        if($title.length) {
            hei = Math.round( $title.height() / 51.0 );
            text = $title.text();
            if(hei > 1) {
                //alert($title.text() + " / " + $title.height());
                $title.css({ "font-size": "0.85em"});
                $title.closest("button").css({ "line-height": "0.9" });
            }
        }
    })

    // Hide subfolders
    $("nav dd.folder").children("dl").hide();

    // Add help text
    $("nav dd.folder").children("div").find("button.item_icon").addClass("manual").attr("help", LOCALIZE["expand-subpages"]);
    $("nav dt").children("div").find("button.item_icon").addClass("manual").attr("help", LOCALIZE["fold-subpages"]);

    // Un-hide current tree brench
    var $dl = $("nav div.current").closest("dl");
    while($dl.parent().closest("dl").length) {
        $dl.show();
        $dl.parent("dd.folder").children("div").find("button.item_icon").addClass("manual").attr("help", LOCALIZE["fold-subpages"]);
        $dl = $dl.parent().closest("dl");
    };
    // Un-hide current subfolder (if any)
    $sub = $("nav div.current").closest("dd").children("dl");
    if($sub.length) { $sub.show(); };


    // Fold expand subfolders list
    $("nav dd.folder").children("div").find("button.item_icon").click(function() {
        var $dd = $(this).closest("dd");
        var $dl = $dd.find("dl").first();
        if($dl.css("display") == "none") {
            $dl.stop().slideDown(250);
            $(this).attr("help", LOCALIZE["fold-subpages"]);
        }
        //else if(!$dd.find(".current").length) { // Do not fold current group
        else {
            $dl.stop().slideUp(250);
            $(this).attr("help", LOCALIZE["expand-subpages"]);
        }

        formResize(250);
    });

    $("nav .action-remove-page").click(function() {
        var $dd = $(this).closest("dd");
        var path = $dd.find(".item_label").attr("href");

        // Check protected files list
        if(protected_files.indexOf(path) > -1 || path.path("extension") == "order") {
            infoPopup(LOCALIZE["file-protected"]);
        }
        // Remove
        else {
            if(detectChanges()) {
                showPopup("fi-alert", LOCALIZE["unsaved-changes-alert"], LOCALIZE["yes-no-buttons"]);
                $("#popup_box .confirm").click(function() { hidePopup(); deletePage(path); });
                $("#popup_box .cancel").click(function() { hidePopup(); return false; });
            }
            else {
                deletePage(path);
            };
        };
        // end
        return false;
    });

    // Click -> edit document
    $("nav div.active_item .item_label").click(function() {
        var $dd = $(this).closest("dd");
        // Add Page
        if($dd.attr("class") == "add_page") {
            if(detectChanges()) {
                showPopup("fi-alert", LOCALIZE["unsaved-changes-alert"], LOCALIZE["yes-no-buttons"]);
                $("#popup_box .confirm").click(function() { hidePopup(); createNewPage($dd); });
                $("#popup_box .cancel").click(function() { hidePopup(); return false; });
            }
            else {
                createNewPage($dd);
            };

        }
        // Go to page
        else {
            href = "index.php?path=" + $(this).attr("href") + "&lang=" + LANG;

            if($(this).find("p .error").length) {
                infoPopup(LOCALIZE["file-folder-not-found"]);
            }
            else if(detectChanges()) {
                showPopup("fi-alert", LOCALIZE["unsaved-changes-alert"], LOCALIZE["yes-no-buttons"]);
                $("#popup_box .confirm").click(function() { $("#loader").fadeIn(500); location.href = href; });
                $("#popup_box .cancel").click(function() { hidePopup(); return false; });
                return false;
            }
            else {
                //alert(href);
                $("#loader").fadeIn(500);
                location.href = href;
            };
        };
    });

    $("nav .action-change-subpages-order").click(function() {
        href = "index.php?path=" + $(this).attr("value");
        if(detectChanges()) {
            showPopup("fi-alert", LOCALIZE["unsaved-changes-alert"], LOCALIZE["yes-no-buttons"]);
            $("#popup_box .confirm").click(function() { $("#loader").fadeIn(500); location.href = href; });
            $("#popup_box .cancel").click(function() { hidePopup(); return false; });
            return false;
        }
        else {
            $("#loader").fadeIn(500);
            location.href = href; 
        };
    });

    $("nav .action-add-subpage").click(function() {
        var $button = $(this);
        if(detectChanges()) {
            showPopup("fi-alert", LOCALIZE["unsaved-changes-alert"], LOCALIZE["yes-no-buttons"]);
            $("#popup_box .confirm").click(function() { hidePopup(); createNewPage($button); });
            $("#popup_box .cancel").click(function() { hidePopup(); return false; });
        }
        else {
            createNewPage($button);
        }
    });
};

function deletePage(path) {
    showPopup("fi-trash", LOCALIZE["page-delete-confirm"] + "<br>\"" + path.path("basename") + "\"<br><br>" + LOCALIZE["page-delete-alert-html"], LOCALIZE["yes-no-buttons"]);
    $("#popup_box .confirm").click(function() {
        $("#cms").attr("action", "_remove.php?path=" + path).submit(); // output
        // Please wait info
        $("#upload_info p").text(LOCALIZE["please-wait"]);
        $("#upload_info").fadeIn(500);
    });        
    $("#popup_box .cancel").click(function() {
        hidePopup();
    });
};

// ==========================================
//           New Page on Template
// ==========================================

function getFilename(file_path) {
    while(file_path.path("extension") != "") {
        file_path = file_path.path("filename");
    }
    return file_path;
}

function createNewPage($button) {
    // Get variables
    templates = false;
    if($button.attr("class") == "add_page") {
        templates = TEMPLATES_LIST["@all"];
        taken = $button.find(".taken_filenames").val().split(";");
        folder = $button.find(".folder_path").val();
    }
    else {
        templates = TEMPLATES_LIST["@all"];
        $item = $button.closest("dd").children("div").find(".item_label");
        href = $item.attr("href");
        folder = href.path("dirname") + "/" + getFilename(href);
        taken = [];
    }

    // Show popup
    if(templates) {

        $("#page_fader, #popup_container").remove();

        html = "<div id='page_fader'></div>" +
            "<div id='popup_container'><div id='popup_box'>" +
            "<p>" + LOCALIZE["new-page-name"] + "</p>" +
            "<input type='text' taken='" + taken.join(";") + "' folder='" + folder + "'>" +
            "<p class='select'>" + LOCALIZE["template-select"] + ":</p>" +
            "<select>";
        for(i in templates) {
            html = html + "<option path='" + TEMPLATES_LIST["@dir"] + templates[i] + "'>" + templates[i].path("filename").replace(/_/g, " ") + "</option>";
        };
        html = html + "</select><br>";
        html = html +
            "<div class='buttons two'><button class='confirm'>" + LOCALIZE["ok-label"] + "</button><button class='cancel'>" + LOCALIZE["cancel-label"] + "</button></div>" +
            "</div></div>";
        $("body").append(html).css({ "overflow-y": "hidden" });

        // Default template selet
        relative_path = folder.substr( SITE_ROOT.length + 1 ).split("/");
        relative_path.shift(); // Get rid off "pages" prefix
        path_depth = relative_path.length;
        default_template = TEMPLATES_LIST[ relative_path[0] ]; // Read templates "master" data
        if(jQuery.type(default_template) == "string" && default_template != "") {
            default_template = default_template.split("/");
            if(path_depth <= default_template.length) {
                default_template = default_template[path_depth - 1];
            }
            else {
                default_template = default_template[0];
            };
            $("#popup_box select option").each(function() {
                if($(this).attr("path") == TEMPLATES_LIST["@dir"] + default_template) {
                    $(this).prop("selected", true);
                }
            })
        };

        $("#page_fader, #popup_container").fadeIn(200, function() {
            $(this).find("input").first().focus();
            // Confirm on enter
            $("#popup_container input").on('keypress', function (e) {
                if(e.which == 13) {
                    $popup_confirm = $(this).closest("#popup_container").find("button.confirm");
                    if($popup_confirm.prop("disabled") != true) {
                        $popup_confirm.trigger( "click" );
                    }
                };
            });
        });

        // Buttons actions
        $("#popup_box button.confirm").click(function() {
            // Filename
            var user_filename = $("#popup_box").find("input").val();
            var filename = user_filename.replace(/@/g, "_-_").replace(/\./g, "_").makeId();
            var template = $("#popup_box").find("option:selected").attr("path");
            //alert(filename);

            if(filename == "") {
                infoPopup(LOCALIZE["page-name-input"]);
                $("#popup_box").find("input").focus();
            }
            else if(taken.indexOf(filename + ".json") > -1 || taken.indexOf(filename + ".json.draft") > -1) {
                infoPopup(LOCALIZE["name-taken-alert"]);
                $("#popup_box").find("input").focus();
            }
            else {
                $form = $("form#cms");
                var new_path = folder + "/" + filename + ".json";                    
                //$("form").append("<textarea name='session_temp'><new_page><user_filename>" + user_filename + "</user_filename></new_page></textarea>");
                link = "index.php?path=" + encodeURIComponent(template) +
                    "&saveas=" + encodeURIComponent(new_path) +
                    "&user_filename=" + encodeURIComponent(user_filename);
                $("#loader").fadeIn(500);
                location.href = link;
            };

        });
        $("#popup_box button.cancel").click(function() { hidePopup(); });
    }
    else {
        alert("createNewPage() data error!")
    }
};

// ==========================================
//             Responsive layout
// ==========================================

function initializeMobile() {
    $(".mobile h1").click(function() {
        toggleMenu();
    })
    $(".mobile .item_option").click(function() {
        toggleMenu();
    });
};

function resposive() {
    win_wid = $(window).width();
    if(win_wid >= 1000) {
        //desktop
        $("nav .nav_container > dl").show();
        $("nav").attr("style", "").removeClass("mobile");
        $("#toogle_mobile_menu").removeClass("visible");
        $("#page_fader").fadeOut(ANIMATION_TIME, function() { $(this).remove() });
        $("footer").fadeIn(ANIMATION_TIME);
    }
    else {
        if($("#toogle_mobile_menu").attr("class") != "visible") {
            $("nav").addClass("mobile").css({ "left": (-1 * $("nav h1").width()) });
            $("nav .nav_container > dl").hide();
        }
    }
};

function toggleMenu() {
    $button = $("#toogle_mobile_menu");
    // Hide
    if($button.attr("class") != undefined && $button.attr("class").indexOf("visible") > -1) {
        $button.removeClass("visible");
        $("nav .nav_container").removeClass("scrolable");
        $("#page_fader").fadeOut(ANIMATION_TIME, function() { $(this).remove() });
        $("nav").stop().animate({ "left": (-1 * $("nav h1").width()) }, ANIMATION_TIME, function() {
            $("nav .nav_container > dl").hide();
        });
        $("footer").fadeIn(ANIMATION_TIME);
        $("nav").css({ "height": "auto" });
        formResize(ANIMATION_TIME);
    }
    // Show
    else {
        $("nav .nav_container > dl").show();
        $("body").append("<div id='page_fader'></div>");
        $("#page_fader").fadeIn(ANIMATION_TIME);
        $("nav .nav_container").addClass("scrolable");
        $button.addClass("visible");
        $("nav").stop().animate({ "left": 0 }, ANIMATION_TIME );
        
        $("#page_fader").click(function() { toggleMenu(); });
        $("footer").fadeOut(ANIMATION_TIME);
        $("nav").css({ "height": $(document).height() });
        initializeMobile();
        formResize(ANIMATION_TIME);
    };
};

function initializeMobileMenuButton() {
    $("#toogle_mobile_menu").click(function() {
        if($("#zoom").length) { $("#zoom .close").click(); }
        $(this).blur();
        toggleMenu();
    })
};

// ==========================================
//            Tree Brench Layout
// ==========================================

function showTreeBrench($item) {
    $dl = $item.closest("dl");
    while($dl.parent().closest("dl").length) {
        $dl.show();
        $dl = $dl.parent().closest("dl");
    };
};

function launchTreeBrench() {
    text_path = EDIT_PATH.substr(SITE_ROOT.length).replace(/\//g, "<span>/</span>");

    $("#path_info").html("<a href='" + EDIT_PATH + "' target='_blank'>" + text_path + "</a>");
    //$("#path_info").html("<a href='" + SAVE_PATH + "'>" + SAVE_PATH + "</a>");

    // Tree brenches icons layout
    $("nav dl").each(function() {
        $(this).find("dd").each(function() {
            $dd = $(this);

            if($dd.next("dd").length) {
                $dd.children("div").find(".item_indent").last().addClass("brench-t");
            }
            else {
                $dd.children("div").find(".item_indent").last().addClass("brench-l");
            };

            $folder = $(this);
            if($folder.length) {
                depth = 1;
                while($folder.parent().closest("dd.folder").length) {
                    depth++;
                    if($folder.parent().closest("dd.folder").next("dd").length) {
                        $indent_icons = $dd.children("div").find(".item_indent");
                        $icon = $dd.children("div").find(".item_indent").eq($indent_icons.length - depth);
                        if($icon.length) { $icon.addClass("brench-i"); };
                    }
                    $folder = $folder.parent().closest("dd.folder");
                };
            };
        });
    });

    if(EDIT_PATH.path("extension") == "order") {
        $("nav .action-change-subpages-order").each(function() {
            if($(this).attr("value") == EDIT_PATH) {

                $folder = $(this).closest("dd.folder");

                showTreeBrench($folder.children("dl"))

                $folder.children("dl").children("dd").find(".nav_item").addClass("current");
                $folder.children("dl").children("dd.add_page").find(".nav_item").removeClass("current");

                folder = $folder.children("div").find(".item_label .lang_title").html();
                folder = [];

                $folder.children("div").find(".item_label .lang_title").each(function() {
                    folder[folder.length] = $(this)[0].outerHTML;
                })

                $("h2").html(LOCALIZE["subpages-order"] + " <span>/ " + LOCALIZE["in-group"] + " " + folder.join("") + "</span>");
            }
        })
    }

    $("nav p .error").closest("div").find(".item_options_box").remove();

    // ====== Nav main group fold / expand ======
    $("nav dl dt > .nav_group_title .item_icon, nav dt > .nav_group_title .item_label").click(function() {

        $dl = $(this).closest("dl");
        $dd = $dl.children("dd");

        if($dd.css("display") == "none") {
            $(this).attr("help", LOCALIZE["fold-subpages"]);
            $dd.slideDown(ANIMATION_TIME, function() {
                //longTitles();
            });
        }
        //else if(!$dd.find(".current").length) { // Do not fold current group
        else {
            $(this).attr("help", LOCALIZE["expand-subpages"]);
            $dd.slideUp(ANIMATION_TIME);
        }
    })

    // ====== Fold Nav groups if not all fits in a browser window ======
    if($("#site_nav_autoexpand").length) { var NAV_AUTOEXPAND = $("#site_nav_autoexpand").val().split(","); } else { var NAV_AUTOEXPAND = []; };
    if($("#site_nav_autofold").length) { var NAV_AUTOFOLD = $("#site_nav_autofold").val().split(","); } else { var NAV_AUTOFOLD = []; };

    function lastVisible() {
        $last = $("#page_preview");
        last_bottom = $last.offset().top + $last.height() + (parseInt($last.css("padding-top")) * 2);
        win_hei = $(window).height();
        if(win_hei >= (last_bottom + 5)) {
            return true;
        }
        else {
            return false;
        }
    };

    setTimeout(function() {
        if(!lastVisible()) {
            if($("nav dd div.current").length) {
                $("nav dt").each(function() {
                    label = $(this).find(".item_label p").html().split("<").shift();
                    if(NAV_AUTOEXPAND.indexOf(label) < 0) {
                        $dl = $(this).closest("dl");
                        if(!$dl.find("dd div.current").length) {
                            $dl.children("dd").slideUp(ANIMATION_TIME);
                            $(this).find(".item_icon").attr("help", LOCALIZE["expand-subpages"]);
                        }
                    };
                })
            }
        }
    
        $("nav dt").each(function() {
            label = $(this).find(".item_label p").html().split("<").shift();
            $dl = $(this).closest("dl");
            if(!$dl.find("div.current").length && NAV_AUTOFOLD.indexOf(label) > -1) {
                $dl.children("dd").slideUp(ANIMATION_TIME);
                $(this).find(".item_icon").attr("help", LOCALIZE["expand-subpages"]);
            }
        })

    }, ANIMATION_TIME);

    // ====== Fold Nav groups specified in ini_fold ======
    setTimeout(function() {
        $("nav dt input.ini_fold").each(function() {
            $dl = $(this).closest("dl");
            $dd = $dl.children("dd");
            if(!$dl.find("dd").children("div.current").length) { // Do not fold current group
                $dd.slideUp(ANIMATION_TIME);
            }
        })
    }, ANIMATION_TIME);
};

// ==========================================
//            Subpages count info
// ==========================================

function countInfo($dd) {
    $label = $dd.children(".nav_group_title").find(".item_label p");
    $dl = $dd.children("dl");
    count = $dl.children("dd").length;
    if($dl.children("dd.add_page").length) { count--; };
    $label.find(".active_mode").first().before("<small class='pages_count'>(" + count + ")</small>");
    $dl.children("dd.folder").each(function() { countInfo($(this)); });
};

function launchCountInfo() {
    $("nav dt").each(function() {
        $label = $(this).find(".item_label p");
        label = $label.html();
        $dl =  $(this).closest("dl");
        count = $dl.children("dd").length;
        if($dl.children("dd.add_page").length) { count--; };
        $label.html(label + "<small class='pages_count'>(" + count + ")</small>");
        $dl.children("dd.folder").each(function() { countInfo($(this)); });
    })
};

// ==========================================
//            Page preview button
// ==========================================

function launchPreviewPageButton() {
    $a = $("#page_preview").closest("a");
    href = $a.attr("href");
    link = $a.attr("data-link");
    if(
        $("nav dd > div.current").length &&
        $("nav dd > div.current").closest("dd").attr("data-type") == "page"
    ) {
        $a.attr("data-link", href + link);
    }
    else {
        $a.attr("data-link", href + "xable-preview/");
    }
    // Update language on click
    $a.click(function() {
        $("#lang li").each(function() { if($(this).css("display") != "none") { lang = $(this).attr("value"); }; });
        link = $(this).attr("data-link");
        link = link.replace(/@language/, lang); // add laguage if exists in pattern
        $(this).attr("href", link);
    })
};
