<?php

    require("modules/_session-start.php");
    require("modules/_update_version.php");

    $back_url = $_SESSION["back_url"];
    $admin_lang = $_SESSION["admin_lang"];
    $edit_lang = $_POST["language"];
    $find = lowercase($_POST["find"]);
?>

<!doctype html>
<html lang='<?php echo $_SESSION["admin_lang"]; ?>'>
	<head>
        <style><?php include "style/loader.css"; ?></style>
        
		<meta charset="UTF-8">
		<title><?php echo localize("xable-search"); ?></title>
        <meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=0">
        
		<link rel="stylesheet" type="text/css" href="style/index.css<?php echo "?v=".$last_update; ?>" />
		<link rel="stylesheet" type="text/css" href="style/cms.css<?php echo "?v=".$last_update; ?>" />
        <link rel="stylesheet" type="text/css" href="style/colors.css<?php echo "?v=".$last_update; ?>" />
        <link rel="stylesheet" type="text/css" href="style/popup_panel.css<?php echo "?v=".$last_update; ?>" />
        <link rel="stylesheet" type="text/css" href="style/_responsive.css<?php echo "?v=".$last_update; ?>" />
		<link rel="stylesheet" type="text/css" href="style/foundation-icons.css" />
		<link href='https://fonts.googleapis.com/css?family=Lato:100,300,400,700,900|Inconsolata:400,700|Audiowide&subset=latin,latin-ext' rel='stylesheet' type='text/css'>
		
        <?php require "modules/_jquery_lib.php"; ?>
	</head>
    
	<body>
        <div id='loader'>
            <div id="loadingProgressG">
                <div id="loadingProgressG_1" class="loadingProgressG"></div>
            </div>
        </div>
        
        <form id="search" action='search.php' method='post'>
            <div id="page_fader"></div>
            <div id="popup_container">
                <div id="popup_box">
                    <h6><span class="fi-magnifying-glass"></span></h6>
                    <?php echo "<h3>".localize("search-label")."<br><span class='info'>".localize("language-label").": ".uppercase($edit_lang)."</span></h3>\n"; ?>


                    <div class='inputs'>
                        <div class='text search_box'>
                            <?php
                                echo "<input class='hidden' id='admin_lang' name='language' value='".$admin_lang."'>\n";
                                echo "<input class='hidden' id='edit_lang' name='language' value='".$edit_lang."'>\n";
                                echo "<input class='hidden' id='back_url' name='back_url' value='".$back_url."'>\n";
                                echo "<input type='text' id='find' name='find' value='".$find."'>\n";
                                echo "<div class='buttons'><button class='search'><span class='fi-magnifying-glass'></span></button></div>\n";
                            ?>
                        </div>
						<?php
                        
                            function searchTreeXml($path, $title, $edit_lang) {
								
                                $find = lowercase($_POST["find"]);
                                $found = [];
                                $xml = loadXml($path, "draft", true); // force draft
								
                                foreach(array_keys($xml) as $article_name) {
                                    if(substr($article_name, 0, 1) != "_") {
                                        $article_group = $xml[$article_name];
                                        foreach(array_keys($article_group) as $article_num) {
                                            $article = $article_group[$article_num];
                                            foreach(array_keys($article) as $section_name) {

                                                $type = $article[$section_name][0]["type"][0];
                                                $val = readXml($article, $section_name, $edit_lang);
                                                $text = false;

                                                if($type == "media") {
                                                    $found_files = [];
                                                    $files = explode(";", $val);
                                                    foreach(array_keys($files) as $num) {
                                                        $file = $files[$num];
                                                        if(path($file, "extension") != "") {
                                                            if(strstr(lowercase($file), $find)) {
                                                                $found_files[$num] = $file;
                                                            }
                                                        }
                                                    }
                                                    if(count($found_files)) {
                                                        $found[] = [ "path" => $path, "title" => $title, "text" => join(";", $found_files), "id" => "$article_name $article_num $section_name ".join(";", array_keys($found_files)) ];
                                                    }
                                                }

                                                elseif($type == "table") {
                                                    foreach(array_keys($val) as $row_num) {
                                                        $row = explode(";", $val[$row_num]);
                                                        foreach(array_keys($row) as $cell_num) {
                                                            $cell = $row[$cell_num];
                                                            $cell = str_replace("[br]", "<br>", $cell);
                                                            if($cell != "" && strstr(lowercase($cell), $find)) {
                                                                $text = preg_replace("/(".$find.")/i", "<span class='search-found'>$1</span>", $text);
                                                            }
                                                        }
                                                    }
                                                }
												
                                                elseif(is_string($val) && $val != "" && strstr(lowercase($val), $find)) {
                                                    $text = str_replace("[br]", "<br>", $val);
                                                    $text = preg_replace("/(".$find.")/i", "<span class='search-found'>$1</span>", $text);
													
                                                };
                                                
                                                if($text) {
                                                    $found[] = [ "path" => $path, "title" => $title, "text" => $text, "id" => "$article_name $article_num $section_name" ];
                                                };
                                                
                                                
                                            }
                                        }
                                    }
                                }
                                
                                if(count($found) > 0) { return $found; }
                                else { return false; };
                            }
                            
                            function searchTree($group, $pages_root, $parents = "", $edit_lang) {
                                $found = [];
                                foreach(array_keys($group) as $href) {
                                    $path = "$pages_root/$href.json";
                                    $data = $group[$href];
                                    $title = $data["title"][$edit_lang];
                                    if($parents != "") { $title = $parents." / ".$title; };
                                    if($sub_found = searchTreeXml($path, $title, $edit_lang)) {
                                        $found = array_merge($found, $sub_found);
                                    };
                                    if(isset($data["subpages"])) {
                                        $sub_group = $data["subpages"];
                                        if($sub_found = searchTree($sub_group, "$pages_root", $title, $edit_lang)) {
                                            $found = array_merge($found, $sub_found);
                                        }
                                        
                                    }
                                }
                                return $found;
                            };
							
							// ====== Get the sitemap array ======
                            //$sitemap = json_decode(file_get_contents("$root/sitemap.json"), true);
							$navigation = loadXml("$root/navigation.json", "draft");
							$tags = explode(";", readXml($settings, "links map_tags"));
							$sitemap = makeSitemap("$root/pages/", "", $tags, $navigation, true);
							
							// ====== Search loop ======
						
                            $found = [];
                            foreach($sitemap as $site_group) {
                                if($sub_found = searchTree($site_group, "$root/pages", false, $edit_lang)) {
                                    $found = array_merge($found, $sub_found);
                                }
                            };

                            if(count($found) > 0) {
                                //echo "<p class='justify-center'><b>".localize("search-results")."</b></p>\n";
                                $image_ext = [ "jpg", "jpeg", "png", "gif", "svg", "bmp" ];
                                
                                echo "<div class='found_box'>\n";
                                foreach($found as $item) {
                                    echo "\t<div class='item_box'>\n";
                                    $link = "index.php?path=".$item["path"]."&lang=".$edit_lang."&found=".$item["id"];
                                    
                                    echo "\t\t<p class='link'><a href='".$link."'><span class='title'>".$item["title"]."</span><br><span class='path'>".$item["path"]."</span></a></p>\n";
                                    //echo "\t\t<p class='key'>".$item["id"]."</p>\n";
                                    
                                    $images = [];
                                    if(count(explode(" ", $item["id"])) == 4) {
                                        foreach(explode(";", $item["text"]) as $file) {
                                            if(in_array(path($file, "extension"), $image_ext) && file_exists("$root/$file")) {
                                                $images[] = $file;
                                            }
                                        }
                                    };
                                    
                                    if(count($images) > 0) {
                                        foreach($images as $file) {
                                            echo "\t\t<div class='article image_box'>\n";
                                            echo "\t\t\t<figure class='thumb' style='background-image:url(\"$root/$file\")'></figure>\n";
                                            echo "\t\t\t<p class='filename'>".$file."</p>\n";
                                            echo "\t\t</div>\n";
                                        }
                                    }
                                    else {
                                        echo "\t\t<div class='article'><p>".$item["text"]."</p></div>\n";
                                    }
                                    
                                    echo "\t</div>\n";
                                }
                                echo "</div>\n";
                            }
                            else {
                                echo "<div class='found_box'>\n";
                                echo "\t<div class='item_box'>\n";
                                echo "<p class=''><b>".localize("nothing-found")."</b></p>\n";
                                echo "\t</div>\n";
                                echo "</div>\n";
                            }
						?>

                    </div>
                    <div class='buttons'>
                        <button class='cancel' href='index.php?path=<?php echo $_POST['back_url']."&lang=".$_POST["language"]; ?>'><?php echo localize("close-label"); ?></button>
                    </div>
                    <div id='close_popup'>
                        <button class='cancel' href='index.php?path=<?php echo urlencode($_GET['page']); ?>'><i class='icon fi-x'></i></button>
                    </div>
                </div>
            </div>
        </form>
        
        <?php 
            if(is_string($popup)) { echo "<input id='popup' value='$popup'>\n"; };
            echo "<input type='hidden' id='saveas' value='".$_GET['page']."'>\n";
            echo "<input type='hidden' id='edit_path' value='".$_GET['page']."'>\n";
            foreach(array_keys($ini_enable) as $key) {
                echo "<input type='hidden' id='enable_$key' value='".$ini_enable[$key]."'>\n";
            };
            foreach(array_keys($_SESSION['ini_site_options']) as $key) {
                echo "\t\t<input type='hidden' id='site_$key' value='".$_SESSION['ini_site_options'][$key]."'>\n";
            };
            echo "<input type='hidden' id='xable_version' value='".$xable_version."'>\n";
            exportLocalization();
        ?>
        
        <script src='script/footer.js<?php echo "?v=".$last_update; ?>'></script>
        <script src='script/index/popups.js<?php echo "?v=".$last_update; ?>'></script>
        <script src='script/search.js<?php echo "?v=".$last_update; ?>'></script>
        
	</body>
</html>
